<?php
/**
 *  Index.php
 *
 *  @author    {$author}
 *  @package   Hdinstaller
 *  @version   $Id: app.action.default.php 573 2008-06-08 01:43:28Z mumumu-org $
 */

/**
 *  Index form implementation
 *
 *  @author    {$author}
 *  @access    public
 *  @package   Hdinstaller
 */
require_once dirname(__FILE__).".php";
class Hdinstaller_Form_JsonCopyfile extends Hdinstaller_Form_Json
{
	function __construct(&$c)
	{
		parent::__construct($c);
		$this->setRequired();
	}
}

/**
 *  Index action implementation.
 *
 *  @author     {$author}
 *  @access     public
 *  @package    Hdinstaller
 */
class Hdinstaller_Action_JsonCopyfile extends Hdinstaller_Action_Json
{
    /**
     *  preprocess Index action.
     *
     *  @access    public
     *  @return    string  Forward name (null if no errors.)
     */
    function prepare()
    {
		if ($this->af->validate() == 0){
			$username = $this->af->get('ftp_username');
			$password = $this->af->get('ftp_password');
		
			// let's copy
			if ($conn_id = ftp_connect('localhost')) {
				if (ftp_login($conn_id, $username, $password)){
					
					$xoops_root_path = $this->af->get('xoops_root_path');
					$remote_path = BASE.'/tmp/html';
					$this->ftpPut($remote_path, $xoops_root_path, $conn_id);
					
					$xoops_trust_path = $this->af->get('xoops_trust_path');
					$remote_path = BASE.'/tmp/xoops_trust_path';
					$this->ftpPut($remote_path, $xoops_trust_path, $conn_id);
					
					//// after script
					$dir777 = array(
						$xoops_root_path.'/cache',
						$xoops_root_path.'/templates_c',
						$xoops_root_path.'/uploads',
						$xoops_root_path.'/uploads/fckeditor',
						$xoops_root_path.'/uploads/wizmobile',
						$xoops_trust_path.'/cache' ,
						$xoops_trust_path.'/templates_c' ,
						$xoops_trust_path.'/uploads' ,
						$xoops_trust_path.'/session' ,
						$xoops_trust_path.'/log' ,
						$xoops_trust_path.'/tmp',
						$xoops_trust_path.'/modules/protector/configs',
						$xoops_trust_path.'/uploads/d3downloads',
						$xoops_trust_path.'/uploads/pico',
						);
					foreach ($dir777 as $_d){
						ftp_chmod($conn_id, 0777, $_d);
					}
					/// mainfile.php
					ftp_chmod($conn_id, 0666, $xoops_root_path.'/mainfile.php');
					ftp_close($conn_id);
					return null;
				}
			}
		}
        return 'json_errorreload';
    }

    /**
     *  Index action implementation.
     *
     *  @access    public
     *  @return    string  Forward Name.
     */
    function perform()
    {
		$this->af->setApp('result', 1);
		$this->af->setApp('next_message', _('Finish XOOPSCube File install'));
		
		$this->backend->ctl->cleanUpTmp();
		
        return 'json_copyfile';
    }
	
	
	
	/// fBNgwňꊇFTPPUT
	/**
	 * @brief 
	 * @param t@ĈfBNg
	 * @param VPUTt@C̃fBNg
	 * @param RlNV
	 * @retval
	 */
	function ftpPut($remote_path, $local_path, $con)
	{
		$file_list = $this->getFileList($remote_path);
		$dir = $file_list['dir'];
		krsort($dir);
		/// UAׂĂdirĂ
		$pos = strlen($remote_path);
		if (!is_dir($local_path)){
			$this->ftp_mkdir($con, $local_path);
		}
		foreach ($dir as $directory){
			$directory = $local_path.substr($directory, $pos);
			if (!is_dir($directory)){
				ftp_mkdir($con, $directory);
			}
		}
		
		/// put files
		foreach ($file_list['file'] as $r_file){
			$l_file = $local_path.substr($r_file, $pos);
			ftp_put($con, $l_file, $r_file, FTP_BINARY);
		}
	}
	
	
	
    /**
     *  fBNgȉ̑SẴt@C
     *
     *  @access private
     */
	function  getFileList($dir, $list=array('dir'=> array(), 'file' => array()))
	{
		if (is_dir($dir) == false) {
			return;
		}

		$dh = opendir($dir);
		if ($dh) {
			while (($file = readdir($dh)) !== false) {
				if ($file == '.' || $file == '..'){
					continue;
				}
				else if (is_dir("$dir/$file")) {
					$list = $this->getFileList("$dir/$file", $list);
					$list['dir'][] = "$dir/$file";
				}
				else {
					$list['file'][] = "$dir/$file";
				}
			}
		}
		closedir($dh);
		return $list;
	}
	
	
	/// mkdir -p
	/**
	 * @brief 
	 * @param V쐬fBNg
	 * @param RlNV
	 * @retval
	 */
	function ftp_mkdir($con, $dir)
	{
		$parent = dirname($dir);
        if ($dir === $parent) {
            return true;
        }

        if (is_dir($parent) === false) {
			if ($this->ftp_mkdir($con, $parent) === false) {
                return false;
            }
        }
		
        return ftp_mkdir($con, $dir);
	}
	
}
