var hdFtpInstaller = Class.create({
  
  allparams: '',
    
  initialize: function()
  {
      if ($('ftpcheck_b')){
          var b1 = $('ftpcheck_b')
          Event.observe(b1, 'click', this.checkFtp.bindAsEventListener(this, b1));
      }
  },
  
  checkFtp: function(e, button)
  {
      Element.show($('loading'));
      button.disabled = true;
      Element.addClassName(button, 'loading');
      
      var thisparams = '&ftp_username='+$('ftp_username').value+'&ftp_password='+$('ftp_password').value;
      this.allparams += thisparams;
      
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_ftpcheck=1&lang='+lang+thisparams,
            onComplete: this.onComplete.bind(this, button, 'getRepository',
                                             [$('ftp_username'),$('ftp_password')])
          }
          );
  },
  
  getRepository: function(e, button)
  {
      Element.show($('loading'));
      button.disabled = true;
      Element.addClassName(button, 'loading');
      
      var thisparams = '&repository_url='+$('repository_url').value;
      this.allparams += thisparams;
      
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_getrepository=1&lang='+lang+thisparams,
            onComplete: this.onComplete.bind(this, button, 'selectPackage',
                                             [$('repository_url')])
          }
          );
  },
  
  
  selectPackage: function(e, button)
  {
      Element.show($('loading'));
      button.disabled = true;
      Element.addClassName(button, 'loading');
      
      var packageRadios = $A($('package_list').getElementsByTagName('INPUT'));
      var target_package = '';
      for (var i=0,j=packageRadios.length; i<j; i++){
          if (packageRadios[i].checked){
              target_package = packageRadios[i].value;
          }
      }
      
      var thisparams = '&target_package='+target_package;
      this.allparams += thisparams;
      
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_xoopsparam=1&lang='+lang+thisparams,
            onComplete: this.onComplete.bind(this, button, 'xoopsParam',
                                             packageRadios)
          });
  },
  
  xoopsParam: function(e, button)
  {
      // installFiles
      button.disabled = true;
      Element.show($('installprocess'));
      $('xoops_root_path').disabled = true;
      $('xoops_trust_path').disabled = true;
      
      this.allparams += '&xoops_root_path='+$('xoops_root_path').value+'&xoops_trust_path='+$('xoops_trust_path').value;
      
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_downloadpackage=1&lang='+lang+this.allparams,
            onComplete: this.onCompleteInstallProcess.bind(this, 'extractFile', button)
          });
  },
  
  
  //// install phase
  extractFile: function(button)
  {
      $('installprocessError').innerHTML = '';
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_extractfile=1&lang='+lang+'&'+this.allparams,
            onComplete: this.onCompleteInstallProcess.bind(this, 'copyFile', button)
                                                           
                                                           
          });
  },
  
  copyFile: function(button)
  {
      $('installprocessError').innerHTML = '';
      var ajax = new Ajax.Request(
          './index.php',
          {
            parameters: 'action_json_copyfile=1&lang='+lang+'&'+this.allparams,
            onComplete: this.onCompleteInstallProcess.bind(this, 'installFinish', button)
                                                           
                                                           
          }
          );
  },
  
  installFinish: function(button, http)
  {
      $('installprocessError').innerHTML = '';
      Element.hide($('loading'));
      Element.removeClassName(button, 'loading');
      $('processIndicator').lastChild.className = 'success';
      $('main').innerHTML += http.responseText;
  },
  
  onComplete: function(button, next_action,  forms, http, json)
  {
      Element.removeClassName(button, 'loading');
      Element.hide($('loading'));
      Element.show($(next_action));
      button.disabled = false;
      $(next_action).innerHTML = http.responseText;
      if (json.result && json.result==1){
          // success
          for (var i=0,j=forms.length; i<j; i++){
              forms[i].disabled = true;
          }
          button.disabled = true;
          var next_button = $(next_action+'_b');
          Event.observe(next_button, 'click', this[next_action].bindAsEventListener(this, next_button));
      }
      else {
          // failed
          if (json.error){
              // alert(json.error);
          }
          for (var i=0,j=forms.length; i<j; i++){
              forms[i].disabled = false;
          }
      }
  },
  
  onCompleteInstallProcess: function(next_action, button, http, json)
  {
      var ul = $('processIndicator');
      var li = ul.lastChild;
      
       $('installprocessError').innerHTML = http.responseText;// debug
      
      if (json.result && json.result == 1){
          li.className = 'success';
          var nextli = document.createElement('LI');
          nextli.className = 'process';
          nextli.innerHTML = json.next_message ;
          ul.appendChild(nextli);
          this[next_action](button, http);
      } else {
          li.className = 'failed';
          $('installprocessError').innerHTML = http.responseText;
          button.disabled = false;
          $('xoops_root_path').disabled = false;
          $('xoops_trust_path').disabled = false;
      }
  }
});

Event.observe(window, 'load', function(){
    hfi = new hdFtpInstaller();
});
